# Uses of Class
org.springframework.asm.ClassReader

Packages that use ClassReader
Package
Description
org.springframework.asm
Spring's repackaging of ASM 9.x (with Spring-specific patches; for internal use only).
org.springframework.cglib.core
Spring's repackaging of the CGLIB core package (for internal use only).
org.springframework.cglib.transform
Spring's repackaging of the CGLIB transform package (for internal use only).

## Uses of ClassReader in org.springframework.asm

Methods in org.springframework.asm with parameters of type ClassReader
Modifier and Type
Method
Description
`static Attribute`
Attribute.`read(Attribute attribute, ClassReader classReader, int offset, int length, char[] charBuffer, int codeAttributeOffset, Label[] labels)`
Reads an attribute with the same `Attribute.type` as the given attribute.
`protected Attribute`
Attribute.`read(ClassReader classReader, int offset, int length, char[] charBuffer, int codeAttributeOffset, Label[] labels)`
Reads a `Attribute.type` attribute.
`static Label`
Attribute.`readLabel(ClassReader classReader, int bytecodeOffset, Label[] labels)`
Returns the label corresponding to the given bytecode offset by calling `readLabel(int, org.springframework.asm.Label[])`.
Constructors in org.springframework.asm with parameters of type ClassReader
Modifier
Constructor
Description
``
`ClassWriter(ClassReader classReader, int flags)`
Constructs a new `ClassWriter` object and enables optimizations for "mostly add" bytecode transformations.

## Uses of ClassReader in org.springframework.cglib.core

Methods in org.springframework.cglib.core with parameters of type ClassReader
Modifier and Type
Method
Description
`static String[]`
ClassNameReader.`getClassInfo(ClassReader r)`
`static String`
ClassNameReader.`getClassName(ClassReader r)`

## Uses of ClassReader in org.springframework.cglib.transform

Methods in org.springframework.cglib.transform with parameters of type ClassReader
Modifier and Type
Method
Description
`protected ClassGenerator`
AbstractClassLoader.`getGenerator(ClassReader r)`
`protected ClassGenerator`
TransformingClassLoader.`getGenerator(ClassReader r)`
Constructors in org.springframework.cglib.transform with parameters of type ClassReader
Modifier
Constructor
Description
``
`ClassReaderGenerator(ClassReader r, int flags)`
``
`ClassReaderGenerator(ClassReader r, Attribute[] attrs, int flags)`